.\" Copyright (c) 2010 Stijn van Dongen
.TH "pud" 7 "8 Jan 2010" "pud 1\&.002, 10-008" "MISCELLANEOUS "
.po 2m
.de ZI
.\" Zoem Indent/Itemize macro I.
.br
'in +\\$1
.nr xa 0
.nr xa -\\$1
.nr xb \\$1
.nr xb -\\w'\\$2'
\h'|\\n(xau'\\$2\h'\\n(xbu'\\
..
.de ZJ
.br
.\" Zoem Indent/Itemize macro II.
'in +\\$1
'in +\\$2
.nr xa 0
.nr xa -\\$2
.nr xa -\\w'\\$3'
.nr xb \\$2
\h'|\\n(xau'\\$3\h'\\n(xbu'\\
..
.if n .ll -2m
.am SH
.ie n .in 4m
.el .in 8m
..
.SH NAME
pud \- Portable Unix Documentation for manual pages and faq documents
.SH DESCRIPTION

Portable Unix Documentation or pud currently provides two
mini-languages for authoring in the UNIX environment\&.
The two mini-languages are for writing UNIX manual pages and faq documents\&.
Source documents in pud languages can be compiled to either
cross-linked html or to troff\&. The troff output can be further compiled
into PostScript, pdf, and plain text\&.
.SH Table of Contents

.ZJ 3m 1m "1\&."
NAME
.in -4m
.ZJ 3m 1m "2\&."
DESCRIPTION
.in -4m
.ZJ 3m 1m "3\&."
Table of Contents
.in -4m
.ZJ 3m 1m "4\&."
Portable Unix Documentation extends Aephea and zoem
.in -4m
.ZJ 3m 1m "5\&."
Getting started
.in -4m
.ZJ 3m 1m "6\&."
UNIX manual pages in html, troff and PostScript
.in -4m
.ZJ 3m 1m "7\&."
faq documents in html, troff and PostScript
.in -4m
.ZJ 3m 1m "8\&."
Manuals and faq examples elsewhere
.in -4m
.ZJ 3m 1m "9\&."
DocBook considered harmful
.in -4m
.ZJ 3m 1m "10\&."
Info evil
.in -4m
.ZJ 3m 1m "11\&."
AUTHOR
.in -4m
.ZJ 3m 1m "12\&."
SEE ALSO
.in -4m
.SH Portable Unix Documentation extends Aephea and zoem

Portable Unix Documentation (pud) is part of the \fIAephea
documentation framework\fP\&. Aephea is built on top of
\fBzoem\fP (http://micans\&.org/zoem), an all-purpose
macro/programming language\&. Both Aephea and
pud documents are processed by compiling
them with the zoem processor\&.
The documents themselves are generally well-structured, relatively free
of formatting statements and compact to write\&.
They can be easily extended since the full zoem language is available
from within a pud document\&.

Portable Unix Documentation is currently shipped with \fIAephea\fP\&.
You will also need to install \fIzoem\fP\&.
.SH Getting started

.ZJ 4m 1m "i"
Get and install both
\fBAephea\fP (http://micans\&.org/aephea)
and
\fBzoem\fP (http://micans\&.org/zoem)\&. Follow the instructions
in the Aephea README file, which boil down to this recipe:

.di ZV
.in 0
.nf \fC
Aephea:
   \&./configure --prefix=$AEPHEAPREFIX
   make
   make install

Zoem:
   \&./configure --with-includepath=$AEPHEAPREFIX/share/aephea --prefix=$OTHERPREFIX
   make
   make install
.fi \fR
.in
.di
.ne \n(dnu
.nf \fC
.ZV
.fi \fR

All pud files will be installed as you install Aephea\&. If you are reading this
locally on your system, chances are zoem and Aephea are installed\&.
.in -5m

.ZJ 4m 1m "ii"
On this page read the pointers in section
\fISection\ \&6\fP if you want to write a manual page\&.
Read the pointers in section \fISection\ \&7\fP if you
want to write an faq\&. The fastest way to get up to speed is to copy and
modify a template or existing source document\&.
.in -5m

.ZJ 4m 1m "iii"
While writing your document, consult
the \fBpud-man(7)\fP documentation,
the \fBpud-faq(7)\fP documentation,
and the \fBaephea-base(7)\fP documentation as necessary\&.
.in -5m

.ZJ 4m 1m "iv"
Off you go\&. If you need macro
facilities or programming facilities, zoem is there to assist you\&.
Simple macro tasks are easy to accomplish\&. For more involved stuff you
might want to consult the Zoem User Manual (or zum)\&.
zum should be installed
locally\&.
Alternatively view the latest zum
\fBat micans\fP (http://micans\&.org/zoem/doc/zum\&.html)
or subscribe to the mailing list
(http://micans\&.org/zoem/index\&.html#list)\&.
.in -5m
.SH UNIX manual pages in html, troff and PostScript

With the \fBpud-man(7)\fP
package you create manual pages for output in either
\fItroff\fP (groff, nroff) or html\&. The first can be viewed from a
terminal, the second in a browser\&.

The fictitious \fIbuzzz\fP utility is described in a pud manual
page\&. It is shipped with every zoem distribution and the
manual page should be installed locally
in the same location as its source\&.
If the location is hard to find you can just obtain the
pud source from the zoem source distribution, or alternatively
you may view the latest
\fBbuzzz source\fP (http://micans\&.org/aephea/src/aephea-latest/mac/doc/buzzz\&.azm)
upstream at micans\&.
Further links are to the
\fBPostScript version\fP (http://micans\&.org/aephea/src/aephea-latest/mac/doc/buzzz\&.ps) and the
\fBplain text format\fP (http://micans\&.org/aephea/src/aephea-latest/mac/doc/buzzz\&.txt)\&.

For other examples consider the oldest pud manual page ever written: the
\fBmcl manual page\fP (http://micans\&.org/mcl/man/mcl\&.html),
the same in
\fBPostScript output\fP (http://micans\&.org/mcl/man/mcl\&.ps),
and the
\fBsource for all this\fP (http://micans\&.org/mcl/man/mcl\&.azm)\&.
By using the venerable \fIcol\fP program, the troff output
can be converted to nice looking
\fBplain text format\fP (http://micans\&.org/mcl/man/mcl\&.txt)\&.
Find the
\fBtroff output\fP (http://micans\&.org/mcl/man/mcl\&.1) disclosed as well\&.

There are some 20+ manual pages for
\fBdifferent utilities in the mcl family\fP (http://micans\&.org/mcl/man/)\&.
.SH faq documents in html, troff and PostScript

Create faq documents with \fBpud-faq(7)\fP for output in either \fItroff\fP
(groff, nroff) or html\&. The former can be viewed in a terminal via the UNIX
man page system, the latter can be viewed in a browser\&.

The
\fIpud faq mini-language\fP
is described as a rather trivial faq itself\&. It can be viewed in
\fIPostScript\fP
(compiled from troff compiled from
\fIthe zoem source\fP
and in
\fIplain text\fP
(again compiled from troff)\&.

For examples behold the
\fBbrowsing delight\fP (http://micans\&.org/mcl/man/mclfaq\&.html)
that is the mcl faq, and the
\fBPostScript pleasure\fP (http://micans\&.org/mcl/man/mclfaq\&.ps)\&.
Find the
\fBnoblest format\fP (http://micans\&.org/mcl/man/mclfaq\&.txt), the
\fBimpregnable troff\fP (http://micans\&.org/mcl/man/mclfaq\&.7), and the
\fBsource\fP (http://micans\&.org/mcl/man/mclfaq\&.azm) for all that jazz\&.
.SH Manuals and faq examples elsewhere

\fBOther people\fP exist writing pud\&. Not many yet\&.
Joost van Baal has used the pud-faq package and the pud-man package
to create documentation for
\fBGnuPG (in Dutch)\fP (http://mdcc\&.cx/gnupg/),
\fBcaspar\fP (http://mdcc\&.cx/pub/caspar/caspar-latest/doc/),
and the
\fBstrong (fire)walls of uruk\fP (http://mdcc\&.cx/pub/uruk/uruk-latest/man/)\&.
.SH DocBook considered harmful

People justly wonder why pud turns away from the blazing light of
goodness that is DocBook\&. DocBook does provide manual page elements and
it does support gazillions of output devices\&.
Nevertheless DocBook man pages are a cruelty, a curse
and the bane of all things good and pure\&.

DocBook cannot be written, it cannot be maintained, it cannot be
programmed\&. Yes, XML and DocBook are not \fIsupposed\fP to be
programmed, but where is the decree that man should toil and suffer so
that his documentation would be transmogrifyable into all eternity?

DocBook provides some sort of manual page ontology, describing
supposedly every element you might ever need\&. Inevitably you will
want to do things that are not provided and then you are stuck\&.
DocBook lists and enumerations are painful and limited\&. The verbosity
of DocBook makes a mountain out of what should be a mole hill\&.

pud manual pages are concise and can be easily cross-referenced\&. The
source is a pleasure to read and output from self-documenting commands can
be imported\&. Zoem IO, macro and programming facilities make the
source extendable so that new requirements can be coped with\&.

Wise people argue that one cannot fathom the needs of future generations and
urge the good people of UNIX to use DocBook\&. The fool knows that this
particular premise disproves the thesis and that joy begets joy\&.
Factor the present into the authoring sustainability equation and the
scales tip\&.

At this juncture, I am hesitantly willing to bet that the pud languages
can easily be ported to DocBook\&. None of the pain, all of the gain\&.
The pud \fIitemize\fP environment is a sticking point though\&. It
provides, horrors, a few formatting options\&. Optional paragraphs skips,
compact mode, right-alignment of items, automatic enumeration, and the
fantabulous intermezzo feature\&.
.SH Info evil

The good people of info consider manual pages obsolete\&. What
more is there to say? It is all written
\fBhere\fP (http://micans\&.org/stijn/views/infoinferno\&.html)\&.
.SH AUTHOR

pud was written by Stijn van Dongen\&.
.SH SEE ALSO

.ZI 2m "\fBpud-man(7)\fP"
\ \&
.in -2m
.ZI 2m "\fBpud-faq(7)\fP"
\ \&
.in -2m
.ZI 2m "\fBaephea-base(7)\fP"
\ \&
.in -2m
.ZI 2m "\fBaephea-ref(7)\fP"
\ \&
.in -2m
